# define linear regression (lm) and support vector machine (svm) function
# svm function
f1= function(j,a1,a2,a3)
    {
      H= a1[,j]
      W= a2[,j]

       if (sum(H & W, na.rm=T)< 2) 
          {V3= rep(NA,length(a3[,j]))}

      else 
          {
          mod_svm=svm(H,W,type="eps",kernel="radial")
          V1 = a3[,j]
          V1[!is.na(V1)] = predict(mod_svm,a3[,j],na.rm=T)
          V3= V1
          }
     }

# lm function
f2= function(j,b1,b2,b3)
    {	
      H=b1[,j]
      W=b2[,j]

      if (sum(H & W, na.rm=T)< 2) 
          {V2= rep(NA,length(b3[,j]))}

      else 
          {
           lm.sol=lm(W~H)
           A=summary(lm.sol)$coefficients
           B=A[,1]  
   
           V2= B[1]+ B[2]*b3[,j]
          }
     }

###################################################################################
# Input parameters for the mctp() function
#  x is file name of surrogate training data
#  y is file name of target training data
#  z is file name of surrogate testing data
#  u is output file name of predicted target tissue data by svm
#  v is output file name of predicted target tissue data by lm

mctp= function(x,y,z,u,v)
    {

# read Surrogate, Target training data and surrogate testing data

  Surrogate_training_data= read.table(x,header= T)

  Target_training_data= read.table(y,header= T)

  Surrogate_testing_data= read.table(z,header= T)

  n=dim(Surrogate_testing_data)[1]  # number of samples
  m=dim(Surrogate_testing_data)[2]  # number of probes

  library(e1071) # load svm package
     
  TargetE_svm= sapply(1:m,f1,Surrogate_training_data,Target_training_data,Surrogate_testing_data) # predicted target tissue data using svm

  TargetE_lm= sapply(1:m,f2,Surrogate_training_data,Target_training_data,Surrogate_testing_data) # predicted target tissue data using lm
  
######################################################################
# save predicted target data using lm and svm

  rownames(TargetE_svm)=rownames(Surrogate_testing_data)
  colnames(TargetE_svm)=colnames(Surrogate_testing_data)

  write.table( TargetE_svm, file=u)

  rownames(TargetE_lm)=rownames(Surrogate_testing_data)
  colnames(TargetE_lm)=colnames(Surrogate_testing_data)

  write.table( TargetE_lm, file=v)

#end
    }
######################################################################

